VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "User-Defined Event Test"
   ClientHeight    =   3225
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   4035
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3225
   ScaleWidth      =   4035
   Begin VB.CommandButton cmdFont 
      Caption         =   "Font Size"
      Height          =   495
      Left            =   3480
      TabIndex        =   5
      Top             =   2640
      Width           =   495
   End
   Begin VB.ListBox List1 
      Height          =   1425
      Left            =   1200
      TabIndex        =   4
      Top             =   1680
      Width           =   1695
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Enabled         =   0   'False
      Height          =   435
      Left            =   1500
      TabIndex        =   1
      ToolTipText     =   "Cancel a running task"
      Top             =   1020
      Width           =   1035
   End
   Begin VB.CommandButton cmdGo 
      Caption         =   "&Go"
      Default         =   -1  'True
      Height          =   435
      Left            =   120
      TabIndex        =   0
      ToolTipText     =   "Start the task"
      Top             =   1020
      Width           =   1035
   End
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "E&xit"
      Height          =   435
      Left            =   2880
      TabIndex        =   2
      ToolTipText     =   "Terminate the application"
      Top             =   1020
      Width           =   1035
   End
   Begin VB.Label lblPercentDone 
      Alignment       =   2  'Center
      Caption         =   "0"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   375
      Left            =   780
      TabIndex        =   3
      Top             =   300
      Width           =   2475
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Based on Warren Bedell's Test4 Event example

'Started with project Event4_1
'Separated into two projects within one group

'Modified to use Timer in Class
'This allows for asynchronous processing

'Further modified to use Windows API timer
'Eliminated Form, timer control from Class module
'Makes no difference in execution!

Option Explicit

Private WithEvents moTest1  As CEventTest
Attribute moTest1.VB_VarHelpID = -1
Private mbCancel            As Boolean
Private mbAllDone           As Boolean

Private Sub cmdCancel_Click()

    mbCancel = True

End Sub

Private Sub cmdExit_Click()

    mbAllDone = True
    Unload Me

End Sub

Private Sub cmdGo_Click()

    mbCancel = False
    lblPercentDone.Caption = "0%"
    
    DoEvents

    Me.MousePointer = vbArrowHourglass
    cmdCancel.Enabled = True
    cmdGo.Enabled = False
    cmdExit.Enabled = False
    DoEvents

    'Start a long running process in
    'the class module
    moTest1.StartTask 5, 0.5

    'Start our own code running in this form module
    Call AddToList
    
End Sub

Private Sub AddToList()

    Dim liNdex As Integer
    
    For liNdex = 1 To 2999
    
'************************************************************
        'Allow for this loop to exit when
        'we are unloading the form!
        If mbAllDone Then Exit For
        
        'If you comment the above line,
        'this loop continues after pressing exit button
'************************************************************
        
        'Generate random data
        'Add it to the list box
        Me.List1.AddItem "Item " + CStr(liNdex) + _
            ": " + CStr(1000 * Rnd(1))
        Me.List1.ListIndex = liNdex - 1
        Debug.Print "Adding item " + CStr(liNdex)
        
'************************************************************
        'Need some sort of delay to allow Timer to fire!
        'Really should call the Win32 Sleep API
        DoEvents
        
        'If you comment the above line'
        'the timer event for the class never fires
'************************************************************
                
    Next liNdex
    
End Sub
Private Sub moTest1_PercentDone(ByVal afPercent As Single, _
    abCancel As Boolean)

    'This event is raised by the CEventText
    'class, which returns the Percent value,
    'which we display

    'We also pass the value of Cancel back to
    'the class in the second argument. This will
    'be true if we press the Cancel button

    lblPercentDone.Caption = CInt(100 * afPercent) & "%"

    DoEvents

    abCancel = mbCancel

    'Handle the final stuff when we hit 90%
    If afPercent > 0.895 Then
        cmdExit.Enabled = True
        
'************************************************************
        'Really should NOT re-enable this button,
        'Since it will call AddToList again!
        'cmdGo.Enabled = True
        
        'If you un-comment the above line,
        'then press Go to rerun the Timer/Class,
        'AddToList is re-entered, and runs VERY SLOWLY
'************************************************************
        
        cmdCancel.Enabled = False
        Me.MousePointer = vbDefault
        DoEvents
        
        If Not mbCancel Then
            lblPercentDone.Caption = "Done"
        Else
            lblPercentDone.Caption = "Canceled"
        End If
            
    End If

End Sub


Private Sub Form_Terminate()

    Set moTest1 = Nothing

End Sub

Private Sub Form_Initialize()
    
    Set moTest1 = New CEventTest

End Sub

Private Sub cmdFont_Click()

    Call ChgFontSize(Me)

End Sub

