Attribute VB_Name = "TimerSetKill"
Option Explicit

Declare Function SetTimer Lib "user32" _
    (ByVal hwnd As Long, _
     ByVal nIDEvent As Long, _
     ByVal uElapse As Long, _
     ByVal lpTimerFunc As Long) As Long
Declare Function KillTimer Lib "user32" _
    (ByVal hwnd As Long, _
     ByVal nIDEvent As Long) As Long

'Module level object refers to Class instance
Private moTester As CEventTest
'Module level variable for Timer ID
Private mlTimer  As Long

Public Sub StartTimer(aoCaller As CEventTest)
  
    'Set module level object variable
    'Will be used by timer to start Long Task
    Set moTester = aoCaller
    
    'Start the timer. Note the use of the AddressOf operator
    'to pass the address of the timer procedure to Windows.
    'When the timer fires, the callback procedure will be
    'called. The timer will continue to fire at 2000 millisecond
    'intervals until it is explicitly terminated with a call to
    'KillTimer. Because we are using a callback, the first two
    'parameters of SetTimer, the HWnd and event ID, are not used.
    
    mlTimer = SetTimer(0, 0, 2000, AddressOf TimerProc)

End Sub

Public Sub TimerProc(ByVal hwnd As Long, _
    ByVal msg As Long, _
    ByVal idEvent As Long, _
    ByVal curTime As Long)

    'Disable timer - only execute code once
    KillTimer 0, mlTimer
    mlTimer = 0
    
    'Now start the long task
    moTester.LongTask

    'Clear the object reference
    Set moTester = Nothing
    
End Sub

